*********** simulation de l'irpp
*********** choix de l'anne de simulation dans do_appel_parametres
*********** Choix du rpertoire racine dans do_appel_parametres ( excuter en premier)

clear

set mem 500m 
set more off


/******** appel des paramtres*/
do Programmes/do_appel_parametres

/******** appel des variables*/
use Fichiers/indiv_demo_$annee, clear
keep  id_indiv pondv decl conj pac marie nenf nenfmaj nadul age nbh sal_irpp nonsal_irpp chom_irpp pension_irpp change p1
sort id_indiv
merge id_indiv using Fichiers/indiv_rev_$annee
drop _merge rfin* rfon* yk*
sort id_indiv
merge id_indiv using Fichiers/indiv_conj_$annee
drop _merge
sort id_indiv
merge id_indiv using Fichiers/indiv_ded_$annee
keep  id_indiv pondv decl conj pac marie nenf nenfmaj nadul age nbh y_irpp_foy y_irpp sal_irpp nonsal_irpp nonsal_irpp_foy nonsalexo_irpp_foy sal_irpp_conj nonsal_irpp_conj chom_irpp pension_irpp_foy pension_irpp sal_irpp_conj chom_irpp_conj pension_irpp_conj sal_irpp_pac chom_irpp_pac pension_irpp_pac rfon*foy rfin*foy age_conj seul_enf_irpp seul_enfmaj_irpp frais_prof* pens_alim* def* ded* red* change p1
sort id_indiv
gen calage=0


/****************phase 1: calcul du revenu imposable*/

/*********phase 1-1: revenu brut global = somme des revenus catgoriels imposables*/ 

/***salaires et allocations chmage imposables*/
gen salchom_imp=max(min(sal_irpp+chom_irpp-min(max($tx_abt_sal*(sal_irpp+chom_irpp),$min_abtsal),$max_abtsal),sal_irpp+chom_irpp-frais_prof),0)
replace salchom_imp=salchom_imp+max(min(sal_irpp_conj+chom_irpp_conj-min(max($tx_abt_sal*(sal_irpp_conj+chom_irpp_conj),$min_abtsal),$max_abtsal),sal_irpp_conj+chom_irpp_conj-frais_prof_conj),0)
replace salchom_imp=salchom_imp+max(sal_irpp_pac+chom_irpp_pac-min(max($tx_abt_sal*(sal_irpp_pac+chom_irpp_pac),$min_abtsal),$max_abtsal),0)

/***pensions de retraite imposables*/
gen pension_imp=max(pension_irpp_foy-min(max($tx_abt_sal*pension_irpp_foy,min($tx_abt_sal*pension_irpp,$min_abtpen)+min($tx_abt_sal*pension_irpp_conj,$min_abtpen)+min($tx_abt_sal*pension_irpp_pac,$min_abtpen)),$max_abtpen),0)

/***revenus non salaris imposables*/
gen nonsal_imp=nonsal_irpp_foy-nonsalexo_irpp_foy

/***revenus fonciers imposables*/
gen rfon_imp=(1-$abt_micro_fon)*rfon_micro_irpp_foy+cond(rfon_normal_irpp_foy-rfon_defcat_foy>0,cond(rfon_normal_irpp_foy-rfon_defcat_foy-rfon_defglo_foy>0,cond(rfon_normal_irpp_foy-rfon_defcat_foy-rfon_defglo_foy-rfon_defcat_ant_foy>0,rfon_normal_irpp_foy-rfon_defcat_foy-rfon_defglo_foy-rfon_defcat_ant_foy,0),rfon_normal_irpp_foy-rfon_defcat_foy-rfon_defglo_foy),-rfon_defglo_foy)
replace rfon_imp=rfon_imp+(1-$abt_micro_fon)*rfon_micro_irpp_foy

/***revenus financiers imposables*/
gen rfin_imp=max(rfin_av_bar_irpp_foy-$abt_av*(nadul-nenfmaj),0)
replace rfin_imp=rfin_imp+max(rfin_div_bar_irpp_foy*(1-$tx_abt_rcm)-$abt_rcm*(nadul-nenfmaj),0)
replace rfin_imp=rfin_imp+rfin_int_bar_irpp_foy

/***calcul du revenu brut global*/
gen rbg_irpp=salchom_imp+pension_imp+nonsal_imp+rfon_imp+rfin_imp+pens_alim_rec_foy

/***dficits globaux annes antrieures*/
replace rbg_irpp=max(rbg_irpp-defglo_ant_foy,0)


/*********phase 1-2: revenu imposable = revenu brut global - charges dductibles*/

/** csg dductible sur revenus du capital*/
gen csg_yk_ded=$tx_csg_ded_rk*(rfin_bar_irpp_foy+rfon_irpp_foy)
gen rimp_irpp=max(rbg_irpp-csg_yk_ded,0)

/** pensions alimentaires verses*/
replace rimp_irpp=max(rimp_irpp-pens_alim_ver_foy,0)

/** dductions pargne retraite*/
replace rimp_irpp=max(rimp_irpp-ded_epar_ret_foy,0)

/** abattement spcial personnes ges*/
gen abt_pers_age=$abt_pers_age*(cond(age>=65,1,0)+marie*cond(age_conj>=65,1,0))*(cond(rimp_irpp<=$plaf_pers_age1,1,0)+0.5*cond(rimp_irpp>$plaf_pers_age1,cond(rimp_irpp<=$plaf_pers_age2,1,0),0))
replace rimp_irpp=max(rimp_irpp-abt_pers_age,0)


/*********phase 1-3: revenu fiscal de rfrence = revenu imposable + revenus PL et PV + certaines dductions*/
gen rfr_irpp=rimp_irpp+rfin_pv_irpp_foy+rfin_pl_irpp_foy+abt_pers_age+nonsalexo_irpp_foy


/***************phase 2: calcul de l'impt brut (quotient familal, barme, dcte)*/

/********phase 2-1: calcul du nombre de parts de quotient familial*/
gen nbp0=nadul-nenfmaj
gen nbp_enf=0.5*cond(nenf+nenfmaj>=1,1,0)+0.5*cond(nenf+nenfmaj>=2,1,0)+1*cond(nenf+nenfmaj>=3,1,0)*(nenf+nenfmaj-2)
gen nbp_seul=0.5*cond(seul_enf_irpp==1,1,cond(seul_enfmaj_irpp==1,1,0))
gen nbp=nbp0+nbp_enf+nbp_seul

/*******phase 2-2: calcul de l'impt barme avec et sans enfants*/
/**impt barme sans enfants*/
gen rpp0=rimp_irpp/nbp0
gen irpp_bar0=$txmarg1*max(min(rpp0-$tranche1,$tranche2-$tranche1),0)+$txmarg2*max(min(rpp0-$tranche2,$tranche3-$tranche2),0)+$txmarg3*max(min(rpp0-$tranche3,$tranche4-$tranche3),0)+$txmarg4*max(min(rpp0-$tranche4,$tranche5-$tranche4),0)+$txmarg5*max(min(rpp0-$tranche5,$tranche6-$tranche5),0)+$txmarg6*max(min(rpp0-$tranche6,$tranche7-$tranche6),0)+$txmarg7*max(min(rpp0-$tranche7,$tranche8-$tranche7),0)+$txmarg8*max(min(rpp0-$tranche8,$tranche9-$tranche8),0)+$txmarg9*max(min(rpp0-$tranche9,$tranche10-$tranche9),0)+$txmarg10*max(rpp0-$tranche10,0)
replace irpp_bar0=nbp0*irpp_bar0
/**impt barme avec enfants*/
gen rpp=rimp_irpp/nbp
gen irpp_bar=$txmarg1*max(min(rpp-$tranche1,$tranche2-$tranche1),0)+$txmarg2*max(min(rpp-$tranche2,$tranche3-$tranche2),0)+$txmarg3*max(min(rpp-$tranche3,$tranche4-$tranche3),0)+$txmarg4*max(min(rpp-$tranche4,$tranche5-$tranche4),0)+$txmarg5*max(min(rpp-$tranche5,$tranche6-$tranche5),0)+$txmarg6*max(min(rpp-$tranche6,$tranche7-$tranche6),0)+$txmarg7*max(min(rpp-$tranche7,$tranche8-$tranche7),0)+$txmarg8*max(min(rpp-$tranche8,$tranche9-$tranche8),0)+$txmarg9*max(min(rpp-$tranche9,$tranche10-$tranche9),0)+$txmarg10*max(rpp-$tranche10,0)
replace irpp_bar=nbp*irpp_bar

/*******phase 2-3: application du plafonnement des effets du quotient familial*/
gen reduc_qf0=irpp_bar0-irpp_bar
gen plaf_qf=$plaf_qf*(nbp-nbp0)*2
replace plaf_qf=$plaf_qf_parentisole+$plaf_qf*(nbp-nbp0-1)*2 if seul_enf_irpp==1
replace plaf_qf=$plaf_qf_persseule if seul_enfmaj_irpp==1
gen reduc_qf=min(reduc_qf0,plaf_qf)*cond(seul_enfmaj_irpp==1,0,1)
gen reduc_enfmaj=min(reduc_qf0,plaf_qf)*cond(seul_enfmaj_irpp==1,1,0)
gen irpp_ds=irpp_bar0-reduc_qf-reduc_enfmaj

/*******phase 2-4: autres rductions dr droits simples (demi part supplmentaires etc.)*/
egen masse_irpp_ds=total(irpp_ds*decl*pondv/1000000000)
gen reduc_ds=0
replace reduc_ds=irpp_ds*$masse_reduc_ds/masse_irpp_ds if calage==$calagecn
replace irpp_ds=irpp_ds-reduc_ds

/********phase 2-5: application de la dcte*/
gen decote_irpp=0
replace decote_irpp=min(irpp_ds,($param_decote-irpp_ds)/2) if irpp_ds<$param_decote
gen irpp_brut=max(irpp_ds-decote_irpp,0)

/***************phase 3: calcul de l'impt net (rductions d'impt, plus-values)*/
gen irpp_net=max(irpp_brut-reduc_irpp_foy,0)
gen irpp_pv_foy=$tx_pv*rfin_pv_normal_irpp_foy+$tx_pv1*rfin_pv_options1_irpp_foy+$tx_pv2*rfin_pv_options2_irpp_foy+$tx_pv*rfin_pv_pro_irpp_foy
gen irpp_tot=irpp_net+irpp_pv_foy

/***************phase 4: rduction d'impt pour changement de statut matrimonial*/
/********phase 4-1: calcul de l'impt correspondant  la premire dclaration*/
/***phase 4-1-1: barme*/
gen rpp1=p1*rpp
gen irpp_bar1=$txmarg1*max(min(rpp1-$tranche1,$tranche2-$tranche1),0)+$txmarg2*max(min(rpp1-$tranche2,$tranche3-$tranche2),0)+$txmarg3*max(min(rpp1-$tranche3,$tranche4-$tranche3),0)+$txmarg4*max(min(rpp1-$tranche4,$tranche5-$tranche4),0)+$txmarg5*max(min(rpp1-$tranche5,$tranche6-$tranche5),0)+$txmarg6*max(min(rpp1-$tranche6,$tranche7-$tranche6),0)+$txmarg7*max(min(rpp1-$tranche7,$tranche8-$tranche7),0)+$txmarg8*max(min(rpp1-$tranche8,$tranche9-$tranche8),0)+$txmarg9*max(min(rpp1-$tranche9,$tranche10-$tranche9),0)+$txmarg10*max(rpp1-$tranche10,0)
replace irpp_bar1=nbp*irpp_bar1
/***phase 4-1-2: plafonnement du quotient familial*/
replace rpp0=p1*rpp0
gen irpp_bar10=$txmarg1*max(min(rpp0-$tranche1,$tranche2-$tranche1),0)+$txmarg2*max(min(rpp0-$tranche2,$tranche3-$tranche2),0)+$txmarg3*max(min(rpp0-$tranche3,$tranche4-$tranche3),0)+$txmarg4*max(min(rpp0-$tranche4,$tranche5-$tranche4),0)+$txmarg5*max(min(rpp0-$tranche5,$tranche6-$tranche5),0)+$txmarg6*max(min(rpp0-$tranche6,$tranche7-$tranche6),0)+$txmarg7*max(min(rpp0-$tranche7,$tranche8-$tranche7),0)+$txmarg8*max(min(rpp0-$tranche8,$tranche9-$tranche8),0)+$txmarg9*max(min(rpp0-$tranche9,$tranche10-$tranche9),0)+$txmarg10*max(rpp0-$tranche10,0)
replace irpp_bar10=nbp0*irpp_bar10
gen reduc_qf1=irpp_bar10-irpp_bar1
gen reduc_qf_plaf1=min(reduc_qf1,plaf_qf)
gen irpp_ds1=irpp_bar10-reduc_qf_plaf1
/***phase 4-1-3: dcte*/
gen decote_irpp1=0
replace decote_irpp1=min(irpp_ds1,($param_decote-irpp_ds1)/2) if irpp_ds1<$param_decote
gen irpp_brut1=max(irpp_ds1-decote_irpp1,0)
/********phase 4-2: calcul de l'impt correspondant  la seconde dclaration*/
/***phase 4-2-1: nombre de parts de la seconde dclaration*/
gen nbp02=nbp0
replace nbp02=1 if nbp0==2 & change==1
replace nbp02=2 if nbp0==1 & change==1
gen nbp2=nbp-nbp0+nbp02
/***phase 4-2-2: revenu imposable de la seconde dclaration*/
gen rimp2=(1-p1)*rimp_irpp
replace rimp2=(1-p1)*rimp_irpp/2 if nbp0==2 & change==1
replace rimp2=(1-p1)*rimp_irpp*2 if nbp0==1 & change==1
/***phase 4-2-3: barme*/
gen rpp2=rimp2/nbp2
gen irpp_bar2=$txmarg1*max(min(rpp2-$tranche1,$tranche2-$tranche1),0)+$txmarg2*max(min(rpp2-$tranche2,$tranche3-$tranche2),0)+$txmarg3*max(min(rpp2-$tranche3,$tranche4-$tranche3),0)+$txmarg4*max(min(rpp2-$tranche4,$tranche5-$tranche4),0)+$txmarg5*max(min(rpp2-$tranche5,$tranche6-$tranche5),0)+$txmarg6*max(min(rpp2-$tranche6,$tranche7-$tranche6),0)+$txmarg7*max(min(rpp2-$tranche7,$tranche8-$tranche7),0)+$txmarg8*max(min(rpp2-$tranche8,$tranche9-$tranche8),0)+$txmarg9*max(min(rpp2-$tranche9,$tranche10-$tranche9),0)+$txmarg10*max(rpp2-$tranche10,0)
replace irpp_bar2=nbp2*irpp_bar2
/***phase 4-2-4: plafonnement du quotient familial*/
replace rpp0=rimp2/nbp02
gen irpp_bar20=$txmarg1*max(min(rpp0-$tranche1,$tranche2-$tranche1),0)+$txmarg2*max(min(rpp0-$tranche2,$tranche3-$tranche2),0)+$txmarg3*max(min(rpp0-$tranche3,$tranche4-$tranche3),0)+$txmarg4*max(min(rpp0-$tranche4,$tranche5-$tranche4),0)+$txmarg5*max(min(rpp0-$tranche5,$tranche6-$tranche5),0)+$txmarg6*max(min(rpp0-$tranche6,$tranche7-$tranche6),0)+$txmarg7*max(min(rpp0-$tranche7,$tranche8-$tranche7),0)+$txmarg8*max(min(rpp0-$tranche8,$tranche9-$tranche8),0)+$txmarg9*max(min(rpp0-$tranche9,$tranche10-$tranche9),0)+$txmarg10*max(rpp0-$tranche10,0)
replace irpp_bar20=nbp02*irpp_bar20
gen reduc_qf2=irpp_bar20-irpp_bar2
gen reduc_qf_plaf2=min(reduc_qf2,plaf_qf)
gen irpp_ds2=irpp_bar20-reduc_qf_plaf2
/***phase 4-2-5: dcte*/
gen decote_irpp2=0
replace decote_irpp2=min(irpp_ds2,($param_decote-irpp_ds2)/2) if irpp_ds2<$param_decote
gen irpp_brut2=max(irpp_ds2-decote_irpp2,0)
/********phase 4-3: calcul de la rduction d'impt correspondante*/ 
gen reduc_double_dec=0
replace reduc_double_dec=irpp_brut-irpp_brut1-irpp_brut2*2 if nbp0==2 & change==1
replace reduc_double_dec=irpp_brut-irpp_brut1-irpp_brut2/2 if nbp0==1 & change==1
replace reduc_double_dec=max(reduc_double_dec,0)
/********phase 4-4: calcul du nouvel impt net*/
replace irpp_net=max(irpp_brut-reduc_irpp_foy-$reduc_doub_dec*reduc_double_dec,0)
replace irpp_tot=irpp_net+irpp_pv_foy

/****************phase 5: calcul d'un irpp catgoriel et d'un irpp individuel*/
/*******phase 5-1: attribution de l'irpp barme  chaque catgorie de revenus*/
replace rfon_imp=max(rfon_imp,0)
replace nonsal_imp=max(nonsal_imp,0)
gen rbc_irpp=salchom_imp+pension_imp+nonsal_imp+rfon_imp+rfin_imp+pens_alim_rec_foy
gen irpp_cat=irpp_net+reduc_qf
gen irpp_sal=irpp_cat*(salchom_imp/rbc_irpp)*sal_irpp/(sal_irpp+sal_irpp_conj+sal_irpp_pac+chom_irpp+chom_irpp_conj+chom_irpp_pac)
replace irpp_sal=0 if rbg_irpp==0 | sal_irpp==0
gen irpp_chom=irpp_cat*(salchom_imp/rbc_irpp)*chom_irpp/(sal_irpp+sal_irpp_conj+sal_irpp_pac+chom_irpp+chom_irpp_conj+chom_irpp_pac)
replace irpp_chom=0 if rbg_irpp==0 | chom_irpp==0
gen irpp_pens=irpp_cat*(pension_imp/rbc_irpp)*pension_irpp/pension_irpp_foy
replace irpp_pens=0 if rbg_irpp==0 | pension_irpp==0
gen irpp_nonsal=irpp_cat*(nonsal_imp/rbc_irpp)*nonsal_irpp/nonsal_irpp_foy
replace irpp_nonsal=0 if rbg_irpp==0 | nonsal_irpp==0
gen irpp_rfon=irpp_cat*(rfon_imp/rbc_irpp)*1/(1+marie)
replace irpp_rfon=0 if rbg_irpp==0 | rfon_irpp==0 | pac==1
gen irpp_rfin=irpp_cat*(rfin_imp/rbc_irpp)*1/(1+marie)
replace irpp_rfin=0 if rbg_irpp==0 | rfin_irpp==0 | pac==1
gen irpp_pens_alim=irpp_cat*pens_alim_rec/rbc_irpp
replace irpp_pens_alim=0 if rbg_irpp==0 | pens_alim_rec==0
gen irpp_pv=irpp_pv_foy*1/(1+marie)
replace irpp_pv=0 if pac==1

/*******phase 5-2: irpp et qf individuel*/
gen irpp=irpp_sal+irpp_chom+irpp_pens+irpp_nonsal+irpp_rfon+irpp_rfin+irpp_pv
gen qf=reduc_qf/(1+marie)
replace qf=0 if pac==1
gen qf_prop=0
replace qf_prop=reduc_qf*irpp/(irpp_tot+reduc_qf) if reduc_qf>0 & pac==1


/********************************phase 6: calcul de la ppe*/
/**************phase 6-1: calcul du revenu d'activit individuel au sens PPE*/
gen ya_ppe=sal_irpp+nonsal_irpp/(1-$tx_abt_sal)
gen ya_ppe_pt=ya_ppe if nbh>=$nbh_pt | ya_ppe==0
replace ya_ppe_pt=ya_ppe*$nbh_pt/nbh if nbh<$nbh_pt

/***************phase 6-2: formule de base en fonction du revenu d'activit individuel*/
gen ppe_ind=0 if ya_ppe<$seuil_ppe_min
replace ppe_ind=$tx_ppe*ya_ppe_pt if ya_ppe>=$seuil_ppe_min & ya_ppe_pt<=$seuil_ppe
replace ppe_ind=$tx_ret_ppe*($seuil_ppe_max-ya_ppe_pt) if ya_ppe_pt>$seuil_ppe & ya_ppe_pt<=$seuil_ppe_max
replace ppe_ind=0 if ya_ppe_pt>$seuil_ppe_max

/***************phase 6-3: supplment couples mono-emploi*/
gen ya_ppe_conj=sal_irpp_conj+nonsal_irpp_conj/(1-$tx_abt_sal)
replace ppe_ind=ppe_ind+$supp_ppe_coup if ya_ppe>=$seuil_ppe_min & ya_ppe_pt<=$seuil_ppe_coup & marie==1 & ya_ppe_conj<$seuil_ppe_min 
replace ppe_ind=$tx_ret_ppe_coup*($seuil_ppe_max_coup-ya_ppe_pt) if ya_ppe_pt>$seuil_ppe_coup & ya_ppe_pt<=$seuil_ppe_max_coup & marie==1 & ya_ppe_conj<$seuil_ppe_min 

/***************phase 6-4: supplment personnes  charge*/
gen ppe_enf=0
replace ppe_enf=$supp_ppe_enf*(nenf+nenfmaj) if ya_ppe>=$seuil_ppe_min & ya_ppe_pt<=$seuil_ppe_max & pac==0 & (ya_ppe_conj<$seuil_ppe_min | ya_ppe_conj>$seuil_ppe_max)
replace ppe_enf=$supp_ppe_enf*(nenf+nenfmaj)/2 if ya_ppe>=$seuil_ppe_min & ya_ppe_pt<=$seuil_ppe_max & marie==1 & (ya_ppe_conj>=$seuil_ppe_min | ya_ppe_conj<=$seuil_ppe_max)
replace ppe_enf=$supp_ppe_enf if ya_ppe>=$seuil_ppe_min & ya_ppe_pt>=$seuil_ppe_max & ya_ppe_pt<=$seuil_ppe_max_coup & marie==1 & ya_ppe_conj<$seuil_ppe_min 

/***phase 6-5: supplment parent isol*/
replace ppe_enf=ppe_enf+$supp_ppe_enf if seul_enf_irpp==1 & ya_ppe>=$seuil_ppe_min & ya_ppe_pt<=$seuil_ppe_max
replace ppe_enf=2*$supp_ppe_enf if seul_enf_irpp==1 & ya_ppe>=$seuil_ppe_min & ya_ppe_pt>$seuil_ppe_max & ya_ppe_pt<=$seuil_ppe_max_coup

/***phase 6-6: proratisation et majoration pour temps partiel*/
replace ppe_ind=ppe_ind*nbh/$nbh_pt if nbh<$nbh_pt
replace ppe_enf=ppe_enf*nbh/$nbh_pt if nbh<$nbh_pt
gen ppe_tot=ppe_ind+ppe_enf
gen ppe_brut=ppe_tot
replace ppe_brut=ppe_brut+$maj_ppe_tp*ppe_tot if nbh<$nbh_pt/2
replace ppe_brut=(1-$maj_ppe_tp)*ppe_tot+$maj_ppe_tp*ppe_tot*$nbh_pt/nbh if nbh>=$nbh_pt/2 & nbh<$nbh_pt

/****phase 6-7: plafonnement par rapport au rfr du foyer*/
replace ppe_brut=0 if (rfr_irpp>$seuil_rfr_ppe+$seuil_rfr_ppe_enf*(nbp-1) & nbp0==1) | (rfr_irpp>$seuil_rfr_ppe_coup+$seuil_rfr_ppe_enf*(nbp-2) & nbp0==2)
replace ppe_ind=0 if (rfr_irpp>$seuil_rfr_ppe+$seuil_rfr_ppe_enf*(nbp-1) & nbp0==1) | (rfr_irpp>$seuil_rfr_ppe_coup+$seuil_rfr_ppe_enf*(nbp-2) & nbp0==2)
replace ppe_enf=0 if (rfr_irpp>$seuil_rfr_ppe+$seuil_rfr_ppe_enf*(nbp-1) & nbp0==1) | (rfr_irpp>$seuil_rfr_ppe_coup+$seuil_rfr_ppe_enf*(nbp-2) & nbp0==2)
replace ppe_tot=0 if (rfr_irpp>$seuil_rfr_ppe+$seuil_rfr_ppe_enf*(nbp-1) & nbp0==1) | (rfr_irpp>$seuil_rfr_ppe_coup+$seuil_rfr_ppe_enf*(nbp-2) & nbp0==2)

/****phase 6-8; calcul de la restitution de ppe*/
gen ppe_brut_rest=max(ppe_brut-max(irpp,0),0)


/*************phase 7: sauvegarde d'un fichier avec variables IRPP simules*/
keep  id_indiv pondv decl y_irpp_foy y_irpp rbg_irpp rimp_irpp rfr_irpp nbp nbp0 nbp_enf nbp_seul irpp_bar0 irpp_bar reduc_qf reduc_enfmaj   reduc_ds irpp_ds decote_irpp irpp_brut reduc_irpp_foy reduc_double_dec irpp_net irpp_pv_foy irpp_tot irpp_sal irpp_chom irpp_pens irpp_nonsal irpp_rfon irpp_rfin irpp_pens_alim irpp_pv irpp qf qf_prop ppe_ind ppe_enf ppe_tot ppe_brut ppe_brut_rest rbc_irpp salchom_imp pension_imp nonsal_imp rfon_imp 
order  id_indiv pondv decl y_irpp_foy y_irpp rbg_irpp rimp_irpp rfr_irpp nbp nbp0 nbp_enf nbp_seul irpp_bar0 irpp_bar reduc_qf reduc_enfmaj   reduc_ds irpp_ds decote_irpp irpp_brut reduc_irpp_foy reduc_double_dec irpp_net irpp_pv_foy irpp_tot irpp_sal irpp_chom irpp_pens irpp_nonsal irpp_rfon irpp_rfin irpp_pens_alim irpp_pv irpp qf qf_prop ppe_ind ppe_enf ppe_tot ppe_brut ppe_brut_rest rbc_irpp salchom_imp pension_imp nonsal_imp rfon_imp 
compress
sort id_indiv
save Fichiers/indiv_irpp_$annee, replace







 
