*********** simulation du revenu primaire du capital: revenus fonciers et financiers
*********** choix de l'anne de simulation dans do_appel_parametres
*********** Choix du rpertoire racine dans do_appel_parametres ( excuter en premier)

clear

set mem 500m /*8000m*/
set more off


/******** appel des paramtres*/
do Programmes/do_appel_parametres

/***************** phase 0: appel des donnes*/
use Fichiers/indiv_logt_$annee, clear
keep id_indiv pondv sexe age loyer_fictif loyer_verse bail_pers_phys
sort id_indiv
merge id_indiv using Fichiers/indiv_cotsoc_$annee
drop _merge
keep id_indiv pondv sexe age loyer_fictif loyer_verse bail_pers_phys nonsal_brut_cn
sort id_indiv
merge id_indiv using Fichiers/indiv_rev_$annee
drop _merge
keep id_indiv pondv sexe age loyer_fictif loyer_verse bail_pers_phys nonsal_brut_cn y_irpp rfon* rfin*

/***************** phase 1: revenus fonciers (rels et imputs)*/

/****** phase 1-1: calage des revenus fonciers rels et imputs*/
egen masse_loyer_fictif_sim=total(loyer_fictif*pondv/1000000000)
egen masse_loyer_reel_sim=total(loyer_verse*bail_pers_phys*pondv/1000000000)
gen masse_loyer_sim=masse_loyer_fictif_sim+masse_loyer_reel_sim
gen masse_rfon_fictif=masse_loyer_fictif_sim+0.5*($masse_loyer_brut_cn-masse_loyer_sim)-$masse_rfon_ccf_cn*(masse_loyer_fictif_sim+0.5*($masse_loyer_brut_cn-masse_loyer_sim))/$masse_loyer_brut_cn-$masse_rfon_int_cn
gen masse_rfon_reel=masse_loyer_reel_sim+0.5*($masse_loyer_brut_cn-masse_loyer_sim)-$masse_rfon_ccf_cn*(masse_loyer_reel_sim+0.5*($masse_loyer_brut_cn-masse_loyer_sim))/$masse_loyer_brut_cn
gen rfon_fictif_cn=0
replace rfon_fictif_cn=loyer_fictif*masse_rfon_fictif/masse_loyer_fictif_sim
gen rfon_reel_cn=rfon_irpp*masse_rfon_reel/$masse_rfon_irpp
gen rfon_cn=rfon_fictif_cn+rfon_reel_cn

/******* phase 1-2: imputation proportionnelle de la taxe foncire*/
gen masse_tf_fictif=$masse_tf_cn*(masse_loyer_fictif_sim+0.5*($masse_loyer_brut_cn-masse_loyer_sim))/$masse_loyer_brut_cn
gen masse_tf_reel=$masse_tf_cn*(masse_loyer_reel_sim+0.5*($masse_loyer_brut_cn-masse_loyer_sim))/$masse_loyer_brut_cn
gen tf_fictif=rfon_fictif_cn*masse_tf_fictif/masse_rfon_fictif
gen tf_reel=rfon_reel_cn*masse_tf_reel/masse_rfon_reel
gen tf=tf_fictif+tf_reel

/********* phase 1-3: sauvegarde du fichier simul*/
sort id_indiv
save Fichiers/indiv_revcap_$annee, replace
/*********prparation d'un tableau de rsultat*/
merge id_indiv using Fichiers/indiv_logt_$annee
egen masse_loyer_fictif_empr_sim=total(loyer_fictif*pondv*proprio_empr/1000000000)
egen masse_loyer_verse_pers_mor_sim=total(loyer_verse*(1-bail_pers_phys)*pondv/1000000000)
egen masse_loyer_marche_pers_mor_sim=total(loyer_marche*(1-bail_pers_phys)*pondv/1000000000)
egen masse_loyer_conso_sim=total(loyer_conso*pondv/1000000000)
egen masse_loyer_conso_loge_sim=total(loyer_conso*loge*pondv/1000000000)
egen n_proprio=total(proprio*pondv/1000000)
egen n_proprio_acced=total(proprio_empr*pondv/1000000)
egen n_locat_phys=total(locat*bail_pers_phys*pondv/1000000)
egen n_locat_mor=total(locat*(1-bail_pers_phys)*pondv/1000000)
egen n_loge=total(loge*pondv/1000000)
gen proprio_bailleur=0
replace proprio_bailleur=1 if rfon_irpp>0
egen n_proprio_bailleur=total(proprio_bailleur*pondv/1000000)
replace proprio_bailleur=1 if proprio==1
egen n_proprio_tot=total(proprio_bailleur*pondv/1000000)
gen assiette_loyer_cn=masse_loyer_sim/$masse_loyer_brut_cn
gen assiette_rfon_reel_cn=$masse_rfon_irpp/(masse_rfon_reel-masse_tf_reel)
collapse masse* n_proprio* n_locat* n_loge assiette*
save Resultats/RevCap/statdes_loyers_$annee, replace
/*********suppression des variables inutiles*/
use Fichiers/indiv_revcap_$annee, clear
drop masse* 
save Fichiers/indiv_revcap_$annee, replace


/************** phase 2: revenus financiers (intrts, dividendes, assurance-vie)*/

/************phase 2-1: calage revenus financiers sur comptanat*/

/*******calcul des masses de revenus financiers exos*/
egen masse_rfin_livret_sim=total(rfin_int_livret_dec*pondv/1000000000)
egen masse_rfin_pel_sim=total(rfin_int_pel_dec*pondv/1000000000)
egen masse_rfin_pea_sim=total(rfin_div_pea_dec*pondv/1000000000)
egen masse_rfin_av_sim=total(rfin_av_dec*pondv/1000000000)

/*******calage des intrts sur les masses comptanat*/
gen rfin_int_livret=rfin_int_livret_dec*$masse_rfin_int_livret/masse_rfin_livret_sim
gen rfin_int_pel_csg=rfin_int_pel_dec*$masse_rfin_int_pel_csg/masse_rfin_pel_sim
gen rfin_int_pel=rfin_int_pel_csg*$masse_rfin_int_pel/$masse_rfin_int_pel_csg
gen rfin_int_pl=rfin_int_pl_irpp*($masse_rfin_pl-$masse_rfin_div_pl_irpp-$masse_rfin_av_pl_irpp)/$masse_rfin_int_pl_irpp
gen rfin_int_csg=rfin_int_pel_csg+rfin_int_pl+rfin_int_bar_irpp
gen rfin_int_cn=rfin_int_livret+rfin_int_pel+(rfin_int_pl+rfin_int_bar_irpp)*($masse_rfin_int_cn-$masse_rfin_int_livret-$masse_rfin_int_pel)/($masse_rfin_pl-$masse_rfin_div_pl_irpp-$masse_rfin_av_pl_irpp+$masse_rfin_int_bar_irpp)

/****** calage des dividendes sur les masses comptanat*/
gen rfin_div_pea_csg=rfin_pea_exo_irpp+rfin_div_pea_dec*($masse_rfin_div_pea_csg-$masse_rfin_pea_exo_irpp)/masse_rfin_pea_sim
gen rfin_div_pea=rfin_div_pea_csg*$masse_rfin_div_pea/$masse_rfin_div_pea_csg
gen rfin_div_csg=rfin_div_pea_csg+rfin_div_bar_irpp+rfin_div_pl_irpp
gen rfin_div_cn=rfin_div_pea+(rfin_div_bar_irpp+rfin_div_pl_irpp)*($masse_rfin_div_cn-$masse_rfin_div_pea)/($masse_rfin_div_bar_irpp+$masse_rfin_div_pl_irpp)

/****** calage des revenus assurance-vie sur les masses comptanat*/
gen rfin_av_csg=rfin_av_bar_irpp+rfin_av_pl_irpp+rfin_av_dec*($masse_rfin_av_csg-$masse_rfin_av_bar_irpp-$masse_rfin_av_pl_irpp)/masse_rfin_av_sim 
gen rfin_av_cn=rfin_av_csg*$masse_rfin_av_cn/$masse_rfin_av_csg

/************phase 2-2: imputation de la csg-crds, des contributions sociales et du pl*/
/**csg-crds sur rk*/
gen rfin_csg=rfin_int_csg+rfin_div_csg+rfin_av_csg+rfin_pv_irpp
gen yk_csg=rfin_csg+rfon_irpp
gen csg_rfin=($tx_csg_ded_rk+$tx_csg_nonded_rk)*rfin_csg
gen csg_rfon=($tx_csg_ded_rk+$tx_csg_nonded_rk)*rfon_irpp
gen csg_yk=csg_rfin+csg_rfon
/**contributions sociales additionnelles sur rk*/
gen csk_rfin=$tx_csk*rfin_csg
gen csk_rfon=$tx_csk*rfon_irpp
egen masse_csk_sim=total((csk_rfin+csk_rfon)*pondv/1000000000)
replace csk_rfin=csk_rfin*$masse_csk_cn/masse_csk_sim
replace csk_rfon=csk_rfon*$masse_csk_cn/masse_csk_sim
gen csk=csk_rfin+csk_rfon
/**prlvement libratoire*/
gen pl=$tx_pl*(rfin_int_pl+rfin_div_pl_irpp)+$tx_pl_av*rfin_av_pl_irpp
egen masse_pl_sim=total(pl*pondv/1000000000)
replace pl=pl*$masse_pl_cn/masse_pl_sim

/************phase 2-3: imputation des profits non-distribus et de l'impt sur les socits*/
gen rfin_dist_cn=rfin_int_cn+rfin_div_cn+rfin_av_cn+rfin_pv_irpp
gen rfin_nondist_cn=rfin_div_cn*$masse_profit_nondist_cn/$masse_rfin_div_cn
gen is=(rfin_int_cn+rfin_div_cn+rfin_av_cn+rfin_nondist_cn)*$masse_is_cn/($masse_rfin_int_cn+$masse_rfin_div_cn+$masse_rfin_av_cn+$masse_profit_nondist_cn)
gen is_af=rfin_div_bar_irpp*$masse_is_cn/($masse_rfin_int_cn+$masse_rfin_div_cn+$masse_rfin_av_cn+$masse_profit_nondist_cn)
gen rfin_cn=rfin_dist_cn+rfin_nondist_cn+is
gen yk_cn=rfin_cn+rfon_cn

/**********************phase 3: calcul du patrimoine individuel par les rendements*/
gen kfon_cn=rfon_cn/$r_fon_cn
gen kfin_int_cn=rfin_int_cn/$r_fin_int_cn
gen kfin_aut_cn=(rfin_cn-rfin_int_cn)/$r_fin_aut_cn
gen kfin_cn=kfin_int_cn+kfin_aut_cn
gen kpro_cn=nonsal_brut_cn*$part_cap_nonsal/$r_cn
gen k_cn=kfon_cn+kfin_cn+kpro_cn
gen kfin_cn1=rfin_cn/$r_fin_cn
gen k_cn1=kfon_cn+kfin_cn1+kpro_cn
gen k_cn0=(yk_cn+nonsal_brut_cn*$part_cap_nonsal)/$r_cn

/**********************phase 4: sauvegarde du fichier simul*/
keep id_indiv pondv sexe age rfon_fictif_cn rfon_reel_cn rfon_cn tf_fictif tf_reel tf rfin_int_livret rfin_int_pel_csg rfin_int_pel rfin_int_pl rfin_int_csg rfin_int_cn rfin_div_pea_csg rfin_div_pea rfin_div_csg rfin_div_cn rfin_av_csg rfin_av_cn rfin_csg yk_csg csg_rfin csg_rfon csg_yk csk_rfin csk_rfon csk pl rfin_dist_cn rfin_nondist_cn is is_af rfin_cn yk_cn k*
order id_indiv pondv sexe age rfon_fictif_cn rfon_reel_cn rfon_cn tf_fictif tf_reel tf rfin_int_livret rfin_int_pel_csg rfin_int_pel rfin_int_pl rfin_int_csg rfin_int_cn rfin_div_pea_csg rfin_div_pea rfin_div_csg rfin_div_cn rfin_av_csg rfin_av_cn rfin_csg yk_csg csg_rfin csg_rfon csg_yk csk_rfin csk_rfon csk pl rfin_dist_cn rfin_nondist_cn is is_af rfin_cn yk_cn k*
sort id_ind
save Fichiers/indiv_revcap_$annee, replace




















